#include <bits/stdc++.h>

using namespace std;

int main(){
    int n,q;
    cin >> n >> q;
    int d[n],p[n],k[q];
    vector<int> v;
    v.push_back(0);
    int k=0;
    for(int i = 0;i < n;i++){
        cin >> d[i] >> p[i];
        for(int j=v.size()-1;j<=d[i];j++){
            if(k){
                v.push_back(v[v.size()-1]+1);
                k--;
            } 
            else{
                v.push_back(v[v.size()-1]);
            }
        }
    }
    int h;
    for(int i=0;i<q;i++){
        cin >> h;
        cout << v[h];
    }
}